#!/usr/bin/env python

#======================================================================#
#
#=========== Light Barrier Demonstration Script 05/04/2014 ============#
#
#  Demo script for Light Barrier
#
#
# www.circuitsurgery.co.uk
#
#======================================================================#

debug = False

import sys
import smbus
import time
import RPi.GPIO as gpio
import spidev

gpio.setmode(gpio.BCM)
gpio.setwarnings(False)

bus = smbus.SMBus(1)
spi = spidev.SpiDev()

#======================================================================#
#	Variables
#----------------------------------------------------------------------#

accel_interrupt = 4
halln = 15
halls = 14
barrier_send = 23
barrier_receive = 24
ip = [halls,halln,barrier_receive,accel_interrupt]		# Input ports
op = [barrier_send]			# Output ports
ball = 0b00011000	# Initial position of "ball" for accelerometer demo
slp = 1.1	# Create floating point variable

results = bytearray()

#======================================================================#
#	Functions
#----------------------------------------------------------------------#


#======================================================================#
#	Addresses
#----------------------------------------------------------------------#
addr_temperature = 0x48
addr_accelerometer = 0x4C
addr_light = 0x29
addr_pressure = 0x60
addr_expander = 0x20
#======================================================================#

#======================================================================#
#	REGISTERS
#----------------------------------------------------------------------#


#======================================================================#
#	BITS in REGISTERS
#----------------------------------------------------------------------#

#======================================================================#
# set GPIO ports
#----------------------------------------------------------------------#
for n in range(4):
	gpio.setup(ip[n],gpio.IN)

gpio.setup(op[0],gpio.OUT)
	
#======================================================================#

#======================================================================#
#======================================================================#
# ---------- SET EXPANSION PORTS FOR OUTPUT ----------
#----------------------------------------------------------------------#

spi.open(0,0)

# Set port expander ports to o/p
resp = spi.xfer2([0x40,0x00,0x00])	# device addr, reg 00, set to 00
# Set all bits to "0"
resp = spi.xfer2([0x40,0x09,0x00])	# device addr, reg 09, set to 00

#=======================================================================
# ** Light Barrier **

print
print "====================== Light Barrier Demonstration ============================="
print "                      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
print ""
print "www.circuitsurgery.co.uk"
print ""

# Sender = GPIO23 = pin16
# Receiver = GPIO24 = pin18

holes = 0		# Initialise holes count
timeout = 0xFFFF
gpio.output(barrier_send,True)	# Illuminate sender

# Count holes in tape
# Wait for tape to be inserted (barrier becomes blocked)
while gpio.input(barrier_receive) == 1: pass

# Hole sensed, add 1 and wait...
while timeout > 0:
	while gpio.input(barrier_receive) == 0: pass	# Wait for hole
	holes += 1
	print holes
	spi.xfer2([0x40,0x09,holes])	# Send to expansion port for visual
	while gpio.input(barrier_receive) == 1:	# wait for hole to pass
		timeout -= 1
		if timeout == 0: break

print "End of strip"











