#!/usr/bin/env python

#======================================================================#
#
#=========== Hall Effect Demonstration Script 05/04/2014 ============#
#
#  Demo script for Hall Effect Switch
#
#
# www.circuitsurgery.co.uk
#
#======================================================================#

debug = False

import sys
import smbus
import time
import RPi.GPIO as gpio
import spidev

gpio.setmode(gpio.BCM)
gpio.setwarnings(False)

bus = smbus.SMBus(1)
spi = spidev.SpiDev()

#======================================================================#
#	Variables
#----------------------------------------------------------------------#

accel_interrupt = 4
halln = 15
halls = 14
barrier_send = 23
barrier_receive = 24
ip = [halls,halln,barrier_receive,accel_interrupt]		# Input ports
op = [barrier_send]			# Output ports
ball = 0b00011000	# Initial position of "ball" for accelerometer demo
slp = 1.1	# Create floating point variable

results = bytearray()

#======================================================================#
#	Functions
#----------------------------------------------------------------------#


#======================================================================#
#	Addresses
#----------------------------------------------------------------------#
addr_temperature = 0x48
addr_accelerometer = 0x4C
addr_light = 0x29
addr_pressure = 0x60
addr_expander = 0x20
#======================================================================#

#======================================================================#
#	REGISTERS
#----------------------------------------------------------------------#


#======================================================================#
#	BITS in REGISTERS
#----------------------------------------------------------------------#

#======================================================================#
# set GPIO ports
#----------------------------------------------------------------------#
for n in range(4):
	gpio.setup(ip[n],gpio.IN)

gpio.setup(op[0],gpio.OUT)
	
#======================================================================#

#======================================================================#
#======================================================================#
# ---------- SET EXPANSION PORTS FOR OUTPUT ----------
#----------------------------------------------------------------------#

spi.open(0,0)

# Set port expander ports to o/p
resp = spi.xfer2([0x40,0x00,0x00])	# device address, register 00, set to 00
# Set all bits to "0"
resp = spi.xfer2([0x40,0x09,0x00])	# device address, register 09, set to 00

#============================================================================


# ** Hall Effect **

print ""
print "=================== Hall Effect Sensor Demonstration ==========================="
print "                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
print ""
print "www.circuitsurgery.co.uk"
print ""

# Out1 = South = GPIO14 = pin8
# Out2 = North = GPIO15 = pin10

while True:
	if gpio.input(halls) == 0:
		print "South"
		spi.xfer2([0x40,0x09,0xF0])
		while gpio.input(halls) == 0: pass	#Wait for condition to change
	else:
		if gpio.input(halln) == 0:
			print "North"
			spi.xfer2([0x40,0x09,0x0F])
			while gpio.input(halln) == 0: pass	#Wait for condition to change
		else:
			print "No Magnet"
			spi.xfer2([0x40,0x09,0x00])
			while gpio.input(halln)&gpio.input(halls) == 1: pass	# wait for magnet to appear













