#!/usr/bin/env python

#======================================================================#
#
#=========== Light Sensor Demonstration Script 05/04/2014 =============#
#
#  Demo script for Light Sensor
#
#
# www.circuitsurgery.co.uk
#
#======================================================================#

print ""
print "====================== Light Sensor Demonstration =============================="
print "                      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
print ""
print "www.circuitsurgery.co.uk"
print ""

import sys
import smbus
import time
import RPi.GPIO as gpio
import spidev

gpio.setmode(gpio.BCM)
gpio.setwarnings(False)

bus = smbus.SMBus(1)
spi = spidev.SpiDev()

#======================================================================#
#	Variables
#----------------------------------------------------------------------#

accel_interrupt = 4
halln = 15
halls = 14
barrier_send = 23
barrier_receive = 24
ip = [halls,halln,barrier_receive,accel_interrupt]		# Input ports
op = [barrier_send]			# Output ports
ball = 0b00011000	# Initial position of "ball" for accelerometer demo
slp = 1.1	# Create floating point variable

results = bytearray()

ip=["v","i"]

#======================================================================#
#	Addresses
#----------------------------------------------------------------------#
addr_temperature = 0x48
addr_accelerometer = 0x4C
addr_light = 0x29
addr_pressure = 0x60
addr_expander = 0x20
#======================================================================#

#======================================================================#
#	REGISTERS
#----------------------------------------------------------------------#

light_reg_control = 0xE0
light_reg_timing = 0xE1
light_reg_threshlowlow = 0xE2
light_reg_threshlowhigh = 0xE3
light_reg_threshhighlow = 0xE4
light_reg_threshhighhigh = 0xE5
light_reg_interrupt = 0xE6
light_reg_data0low = 0xEC
light_reg_data0high = 0xED
light_reg_data1low = 0xEE
light_reg_data1high = 0xEF

#======================================================================#
#	BITS in REGISTERS
#----------------------------------------------------------------------#
#
# Bit ---> |    7   |    6   |    5   |   4  |    3  |   2   |   1   |   0   |
# Command> |   Cmd  |  Clear |  Word  | (Res)| - - - - A D D R E S S - - - - |
#
# Command bits 7:4 must be placed before the register address.
# e.g. to write to the Control register (0x00) the register must be
# addressed as 0xE0 (Cmd=1, Clear=1, Word=1, (Res)=0, + address=0)

#============================================================================

# ** Set up Light Sensor **
# ******* APDS-9300 *******

# Make sure LED's are off!
spi.open(0,0)
spi.xfer2([0x40,0x00,0x00])	#Make all expansion ports o/p
spi.xfer2([0x40,0x09,0x00])	#Make all expansion ports "0"
spi.close()

# Control register bits 0:1 control power up/down:-
#	0x00 = power down, 0x03 = power up

ctl = bus.read_byte_data(addr_light,light_reg_control)
while ctl <> 3:	# Read contents of Control register to verify comms
	# Power chip down first to start from a known position
	# (Control does not seem to like getting "3" written when already
	#		switched on!)
	bus.write_byte_data(addr_light,light_reg_control,0x00)	# Power down
	bus.write_byte_data(addr_light,light_reg_control,0x03)	# Power up
	time.sleep(0.1)
	ctl = bus.read_byte_data(addr_light,light_reg_control)

print "Light sensor powered up successfully"

while True:

	kb = "v"

	results = bus.read_i2c_block_data(addr_light, light_reg_data0low)
	lo0 = results[0]
	hi0 = results[1]
	lo1 = results[2]
	hi1 = results[3]

# create bar-graph just using Ch0 low byte
# Ch1 may be used to look at IR only (remote controls, etc)

	if kb=="v":
		illum = lo0/0x20	# should return max of 8 (one for each LED)
		bar=1
		spi.open(0,0)
		spi.xfer2([0x40,0x09,bar<<illum])
		spi.close()
		
	elif kb=="i":
		illum = lo1/0x20	# should return max of 8 (one for each LED)
		bar=1
		spi.open(0,0)
		spi.xfer2([0x40,0x09,bar<<illum])
		spi.close()







