#!/usr/bin/env python

#======================================================================#
#
#========= SPI/Expansion Port Demonstration Script 05/04/2014 =========#
#
#  Demo script for SPI controlled Expansion Port
#
#
# www.circuitsurgery.co.uk
#
#======================================================================#

debug = False

import sys
import smbus
import time
import RPi.GPIO as gpio
import spidev

gpio.setmode(gpio.BCM)
gpio.setwarnings(False)

bus = smbus.SMBus(1)
spi = spidev.SpiDev()

#======================================================================#
#	Variables
#----------------------------------------------------------------------#
#======================================================================#
#	Addresses
#----------------------------------------------------------------------#

expwrite = 0x40
expread = expwrite+1

#======================================================================#
#	REGISTERS
#----------------------------------------------------------------------#
exp_IODIR = 0x00
exp_IPOL = 0x01
exp_GPINTEN = 0x02
exp_DEFVAL = 0x03
exp_INTCON = 0x04
exp_IOCON = 0x05
exp_GPPU = 0x06
exp_INTF = 0x07
exp_INTCAP = 0x08	#(Read-only)
exp_GPIO = 0x09
exp_OLAT = 0x0A

#======================================================================#
#	Functions
#----------------------------------------------------------------------#
#Flips a byte so that lsb becomes msb... etc
def flipbyte(b):
	result = int('{:08b}'.format(b)[::-1], 2)
	print "Byte: ", b
	print "Result: ", result
	print ""
	return(result)
#======================================================================#
#======================================================================#
# ---------- SET EXPANSION PORTS FOR OUTPUT ----------
#----------------------------------------------------------------------#
print ""
print "============== SPI controlled Expansion Port Demonstration ====================="
print "              ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
print ""
print "www.circuitsurgery.co.uk"
print ""
print "The LEDs will be turned off, then a 'running light' will dash across the display"
print "a couple of times! Following that, each port will be switched to input mode,"
print "one at a time, and the LEDs will correspondingly turn on. The script will then"
print "look for a 'low' condition on each of the inputs and display the numerical value"
print "of the port."
print "End the script by pressing <CTRL+Z>"
print ""
print "Press any key to begin..."
opt = raw_input("")
#Turn LED's off!
spi.open(0,0)	#Open SPI bus
spi.xfer2([expwrite,exp_IODIR,0x00])	#Make all expansion ports o/p
spi.xfer2([expwrite,exp_GPIO,0x00])		#Write "0" to all ports

#Running light, back and forth x 2
for n0 in range(2):
	bit = 1
	for n1 in range(8):
		# The "int('{:08b}'.format(xx)[::-1], 2)" is to flip the bits in the byte
		#spi.xfer2([expwrite,exp_GPIO,int('{:08b}'.format(count)[::-1], 2)])
		spi.xfer2([expwrite,exp_GPIO,bit])
		bit = bit << 1
		time.sleep(0.02)

	for n1 in range(9):
		spi.xfer2([expwrite,exp_GPIO,bit])
		bit = bit >> 1
		time.sleep(0.02)

time.sleep(0.5)	#Pause...

#Make all expansion ports i/p one at a time

#pdir = spi.xfer2([expwrite,exp_IODIR,0xAA])
#print ""
#print "pdir1: ", pdir
#time.sleep(1)
#pdir = spi.xfer2([expread,exp_IODIR,0x55])
#time.sleep(1)
#print "pdir2: ", pdir

bit = 1
pdir = 0
for n0 in range(8):
	pdir = pdir|bit
	spi.xfer2([expwrite,exp_IODIR,pdir])
	bit = bit<<1
	time.sleep(0.25)

print ""
print "Now waiting for inputs on expansion port"
print ""
while True:
	expport = spi.xfer2([expread,exp_GPIO,0])
	if expport[2] <> 0xFF:
		print "Input= ",expport

spi.close()
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	


#============================================================================

