#!/usr/bin/env python

#======================================================================#
#
#======== Temperature Sensor Demonstration Script 05/04/2014 ==========#
#
#  Demo script for Temperature Sensor
#
#
# www.circuitsurgery.co.uk
#
#======================================================================#

print ""
print "=================== Temperature Sensor Demonstration ==========================="
print "                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
print ""
print "www.circuitsurgery.co.uk"
print ""

import sys
import smbus
import time
import RPi.GPIO as gpio
import spidev

gpio.setmode(gpio.BCM)
gpio.setwarnings(False)

bus = smbus.SMBus(1)
spi = spidev.SpiDev()

#======================================================================#
#	Variables
#----------------------------------------------------------------------#

accel_interrupt = 4
halln = 15
halls = 14
barrier_send = 23
barrier_receive = 24
ip = [halls,halln,barrier_receive,accel_interrupt]		# Input ports
op = [barrier_send]			# Output ports
ball = 0b00011000	# Initial position of "ball" for accelerometer demo
slp = 1.1	# Create floating point variable

results = bytearray()

#======================================================================#
#	Addresses
#----------------------------------------------------------------------#
addr_temperature = 0x48
addr_accelerometer = 0x4C
addr_light = 0x29
addr_pressure = 0x60
addr_expander = 0x20
#======================================================================#

#======================================================================#
#	REGISTERS
#----------------------------------------------------------------------#



#======================================================================#
#	BITS in REGISTERS
#----------------------------------------------------------------------#
#
# Bit ---> |  7  |  6  |  5  |  4  |  3  |  2  |  1  |  0  |
# T (msb)> | D10 | D9  | D8  | D7  | D6  | D5  | D4  | D3  |
# T (lsb)> | D2  | D1  | D0  |  X  |  X  |  X  |  X  |  X  |
#
# 

# 11-bit binary
# (two's comp)	Hex value	Dec value	Value
#
# 011 1111 1000		3F8		1016		+127.000 c
# 011 1111 0111		3F7		1015		+126.875 c
# 011 1111 0001		3F1		1009		+126.125 c
# 011 1110 1000		3E8		1000		+125.000 c
# 000 1100 1000		0C8		 200		+ 25.000 c
# 000 0000 0001		001		   1		+  0.125 c
# 000 0000 0000		000		   0		   0.000 c
# 111 1111 1111		7FF		  -1		-  0.125 c
# 111 0011 1000		738		-200		- 25.000 c
# 110 0100 1001		649		-439		- 54.875 c
# 110 0100 1000		648		-440		- 55.000 c


#============================================================================

# ** Set up Temperature Sensor **
# ************ LM75B ************

# ************************************************************
# ** This sort of works, good enough to prove a point.		**
# ** Needs more work to make good enough for demo purposes. **
# ************************************************************

# Make sure LED's are off!

spi.open(0,0)
spi.xfer2([0x40,0x00,0x00])	#Make all expansion ports o/p
spi.xfer2([0x40,0x09,0x00])	#Make all expansion ports "0"
spi.close()

while True:
	results = bus.read_i2c_block_data(addr_temperature,0)
	Temperature = results[0] << 8 | results[1]
	Temperature = Temperature >> 5
	spi.open(0,0)
	spi.xfer2([0x40,0x09,1<<(34-results[0])])
	spi.close()
	print "Temperature =    ", Temperature
	print "---------------------------------------------------"
	
	time.sleep(.5)







